'-------------------------------------------------------------------
' CreateNewDataBase.bas (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to create a new conventional database
'with Plsar 3.0
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"

'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program

'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO: HOW CREATE A NEW DATABASE.",,"PULSAR 3.0 - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename

    '--------------------------------------------------------------------
    'HOW TO CREATE A NEW CONVENTIONAL DATABASE?
    '
    'NewConventionalDB$ packed function allow create a new database file
    'in your disk. Use the Structure$ variable to define the structure
    'coincident with the UDT:
    'TYPE Fields
    '    Apellido  AS STRING * 30    'last name field
    '    Nombres   AS STRING * 40    'first name field
    '    Email     AS STRING * 20    'e-mail field
    '    Web       AS STRING * 50    'web field
    'END TYPE
    'GLOBAL DatabaseRecord is used in this program for contain UDT structure
    '
    'The IndexField$ variable define the index field for ordering the data
    'into file

    Structure$="APELLIDO:30,NOMBRES:40,E-MAIL:20,WEB:50"
    IndexField$="APELLIDO"
    CallPulsar$=NewConventionalDB$(Structure$,IndexField$,PulsarPath$,PulsarFile$)

    IF CallPulsar$<>"ok" THEN
        'If database file is created, the packed function return "ok".
        'If error occur, function return error code in string
        'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
        MSGBOX "OPERATION IS NOT COMPLETED: "+CallPulsar$
        EXIT FUNCTION
    ELSE
        'database is created
        MSGBOX "OPERACION OK."
        EXIT FUNCTION
    END IF


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION
