'-------------------------------------------------------------------
' ModifyARecord.bas (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to modify a record saved in a database
'with Plsar 3.0
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"


'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program

'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO: HOW TO MODIFY A RECORD SAVED.",,"PULSAR 3.0 - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename


    '--------------------------------------------------------------------
    'HOW TO MODIFY A RECORD SAVED IN YOU DATABASE?

    'The ModifyRecordConvDB$ packed function allow modify the data contain
    'in a record saved in you database. If you modify data contain into
    'index field, this function reordering automatically you database.

    DatabaseRecord.Apellido="Ponce (Modify)"
    DatabaseRecord.Nombres ="Richard D."
    DatabaseRecord.Email   ="richard@lanet.com.ar
    DatabaseRecord.Web     ="www.hepika.com.ar/index.htm"

    RecordToModify$="8"   'record number to modify, this number must not
                          'be greater than the last record saved neither
                          'smaller than 1

    NewRecordToSave$=DatabaseRecord   'assign the UDT to NewRecordToSave$
                                      'variable to call the packed function

    CallPulsar$=ModifyRecordConvDB$(PulsarPath$,PulsarFile$,NewRecordToSave$,RecordToModify$)

    IF CallPulsar$<>"ok" THEN
        'If record is modified, the packed function return "ok".
        'If error occur, function return error code in string
        'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
        MSGBOX "OPERATION IS NOT COMPLETED: "+CallPulsar$
        EXIT FUNCTION
    ELSE
        MSGBOX "OPERACION OK."
        EXIT FUNCTION
    END IF


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION
