'-------------------------------------------------------------------
' ReadRecordDirectly.bas (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to read a record directly from data file
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"


'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program


'auxiliar subs (view descriptions into subs)

DECLARE SUB SaveTenRecordsInConvDB
DECLARE SUB ViewRecordsInConventionalDB(FilePath$,FileNameDataBase$)

'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO: HOW TO READ A RECORD DIRECTLY FROM DATA FILE",,"PULSAR 3.0 - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename


    '--------------------------------------------------------------------
    'HOW TO READ A RECORD DIRECTLY FROM DATA FILE?
    '
    'If for any cause you need manipulate the data file that contain
    'the record obviating plsar intervention, get the initial byte in
    'data file that contain the searched record with the ReturnRecordByte$
    'packed function
    '
    'Warning!: The Plsar record manipulation contemplate the network
    '           permissions access. Through this method you expose the
    '           data at corruption or loss
    '
    'This routine allow get all the saved records in you database directly
    'from the data file, without plsar manager intervention

    RecordsInDB$=GetQuantityOfRecords$(PulsarPath$,PulsarFile$) 'get the
                               'quantity of record saved in you database

    IF LEFT$(RecordsInDB$,5)="ERROR" THEN
        'If error occur, function return error code in string
        'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
        MSGBOX "OPERATION IS NOT COMPLETED: "+RecordsInDB$
        EXIT FUNCTION
    END IF

    'plsar return the quantity of record saved in you database
    'and contain it into RecordsInDB$ variable in string
    'format

    'this for/next loop allow read records one to one directly
    'from you data file

    FOR Record&=1 TO VAL (RecordsInDB$)

       'the ReturnRecordByte$ packed function return the initial byte
       'in data file that contain the searched record

       ByteInicio$=ReturnRecordByte$(PulsarPath$,PulsarFile$,TRIM$(STR$(Record&)))

       IF LEFT$(ByteInicio$,5)="ERROR" THEN
           'If error occur, function return error code in string
           'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
           MSGBOX "OPERATION IS NOT COMPLETED: "+RecordsInDB$
           EXIT FOR
       END IF

       'if error not occur, the ByteInicio$ variable contain in
       'string format the byte number

       File$="c:\pulsar\Conventional_DB"+".PLS"  'this is the plsar data file

       'open the plsar data file and read the record
       CLOSE #75
       OPEN File$ FOR BINARY ACCESS READ WRITE LOCK READ WRITE AS #75
       GET #75, VAL(ByteInicio$),DatabaseRecord  'save the record into
       CLOSE #75                                 'DatabaseRecord UTD structure

       'show record readed
       Msg$="RECORD N "+TRIM$(STR$(Record&))+"/ "+TRIM$(RecordsInDB$)+CHR$(10)+CHR$(13)
       Msg$=Msg$+"------------"+CHR$(10)+CHR$(13)
       Msg$=Msg$+DatabaseRecord+CHR$(10)+CHR$(13)
       MSGBOX Msg$

    NEXT Record&


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION
