'-------------------------------------------------------------------
' SAVEARECORDANDREINDEX.BAS (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to save a record in a database and reindex it
'with Plsar 3.0
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"


'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program


'auxiliar subs (view descriptions into subs)

DECLARE SUB SaveTenRecordsInConvDB

'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO",,"PULSAR 3.0 Lite - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename

    '--------------------------------------------------------------------
    'HOW TO SAVE A RECORD INTO DATABASE AND REORDERING THE INDEX TABLE?
    '
    'This routine save 10 records in database file. See description
    'in SaveTenRecordsInConvDB sub
    '
    CALL SaveTenRecordsInConvDB


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION


'------------------------------------------------------------------
'AUXILIAR SUB'S
'------------------------------------------------------------------

SUB SaveTenRecordsInConvDB

   'This sub show how save records in a program

   LOCAL Record$,CAMPO%

   MSGBOX "This subroutine will save 10 records in a conventional database.",,"PLSAR 3.0"

   FOR CAMPO%=1 TO 50 STEP 5

      'this for/next structure allow read the data and save it
      'into database

      DatabaseRecord.Apellido=READ$(CAMPO%)
      DatabaseRecord.Nombres=READ$(CAMPO%+1)
      DatabaseRecord.Email=READ$(CAMPO%+2)
      DatabaseRecord.Web=READ$(CAMPO%+3)
      Record$=READ$(CAMPO%+4)

      RecordToSave$=DatabaseRecord 'assign the record fields saved in DatabaseRecord UDT
                                   'into RecordToSave$ variable for call packed function

      'SaveIndexConvDB$ packed function allow save a record into you database
      'and reordering the index table automatically

      CallPulsar$=SaveIndexConvDB("c:\pulsar","Conventional_DB",RecordToSave$)

      'if not error occur, function return "ok", if error occur, return
      '"ERROR CODE:XXX.Error_Description" string into CallPulsar$ variable

      IF CallPulsar$<>"ok" THEN
         MSGBOX "OPERATION IS NOT COMPLETED IN RECORD:"+Record$+" "+CallPulsar$
         EXIT SUB
      END IF

   NEXT FIELDS%

   MSGBOX " 10 RECORD SAVED !",,"PLSAR 3.0"
   EXIT SUB

   'this data is saved into you database

   DATA "Rosas","Juan Alberto","ja_rosas@supernet.com.ar","http://www.jar.com.ar","1"
   DATA "Ponce","Ricardo Daniel","ricardodp@yahoo.com","http://www.hepika.com.ar","2"
   DATA "Juarez","Roberto","roberto_juarez@yahoo.com","","3"
   DATA "Negrete","Alberto O.","negrete_alberto@yahoo.com.ar","http://www.negrete.com.ar","4"
   DATA "Monta","Norma","normamonta@sheep.com","http://www.monta_ltda.com","5"
   DATA "Morconi","Luis A.","lamorconi@subte.com.ar","http://www.subte.com.ar/morconi","6"
   DATA "Riquelme","Ariel H.","riquelme@hotmail.com","http://www.riquelme.com.jp","7"
   DATA "Onofre","Dario E.","onofre@ciudad.com.ar","http://www.onofre.com","8"
   DATA "Zalazar","Roberto","rzalazar@yahoo.com","http://www.rulo.com.ar","9"
   DATA "Garcia","Esteban","e_garcia@yahoo.com.ar","http://www.garcia_e.com.ar","10"

END SUB
