'-------------------------------------------------------------------
' SAVEARECORDWITHOUTREINDEX.BAS (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to save a record in a database and not reindex it
'with Plsar 3.0
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"


'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program


'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO",,"PULSAR 3.0 Lite - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename


    '--------------------------------------------------------------------
    'HOW SAVE A RECORD IN YOU DATABASE AND NOT REINDEX?
    '
    'SaveConvDB$ packed function save a record in you database
    'without file reindexation.
    'Use it only for massive entry data that not require search
    'duplicated record in database.
    'Inmediately end the data entry, call the ReindexConvDB$ packed
    'function to force the file reindexation

    DatabaseRecord.Apellido="BBB - ultimo"
    DatabaseRecord.Nombres ="bebe"
    DatabaseRecord.Email   ="bebe@rapidq.com.ar
    DatabaseRecord.Web     ="www.bebe.com.ar"

    RecordToSave$=DatabaseRecord   'assign the UDT to RecordToSave$
                                   'variable to call the packed function

    CallPulsar$=SaveConvDB$(PulsarPath$,PulsarFile$,RecordToSave$)
    IF CallPulsar$<>"ok" THEN
        'If record is saved, the packed function return "ok".
        'If error occur, function return error code in string
        'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
        MSGBOX "OPERATION IS NOT COMPLETED: "+CallPulsar$
        EXIT FUNCTION
    ELSE
        'record is saved
        MSGBOX "OPERACION OK."
        EXIT FUNCTION
    END IF


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION
