'-------------------------------------------------------------------
' SAVEONLYIFNOTEXIST.BAS (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to save a record in you database if not exist previously
'with Plsar 3.0
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"


'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program



'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO",,"PULSAR 3.0 Lite - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename


    '--------------------------------------------------------------------
    'HOW TO SAVE A RECORD IN YOU DATABASE (AND REINDEX-IT) ONLY IF NOT
    'EXIST PREVIOUSLY?

    'NOTE: SINEConvDB$ is => Save If Not Exist previously in Convencional DataBase
    '
    'The SINEConvDB$ packed function allow save a record and assure it that this
    'record is not saved prevously. Only save the record if the data contain into
    'index file is not find between the saved records of you database

    DatabaseRecord.Apellido= "Rosas"            'is this record (Rosas) saved?
    DatabaseRecord.Nombres = "Ezequiel Edelmiro"
    DatabaseRecord.Email   = "ezequiel_ponce@rapidq.com.ar
    DatabaseRecord.Web     = "www.ezequiel.com.ar"

    RecordToSave$=DatabaseRecord   'assign the UDT to RecordToSave$
                                   'variable to call the packed function

    CallPulsar$=SINEConvDB$(PulsarPath$,PulsarFile$,RecordToSave$)

    IF CallPulsar$<>"ok" THEN
        'If record is saved, the packed function return "ok".
        'If error occur, function return error code in string
        'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
        MSGBOX "OPERATION IS NOT COMPLETED: "+CallPulsar$

        'NOTE:If record is not saved because exist in you database, SINEConvDB$
        'function return the 123 code error: "CANNOT SAVE RECORD BECAUSE RECORD
        'EXIST IN DATABASE"

        EXIT FUNCTION
    ELSE
        'record is saved
        MSGBOX "OPERACION OK."
        EXIT FUNCTION
    END IF


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION
