'-------------------------------------------------------------------
' VIEWALLRECORDS.BAS (c)2002 by Ricardo Daniel Ponce
' Source code in PowerBasic 7.0
'
' November 2002
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS
' We are programmers... as you
' www.hepika.com.ar
'
'This file show how to view all records saved in a database
'with Plsar 3.0
'-------------------------------------------------------------------

'................................
'Orden de compilacion
#COMPILE EXE
'................................
'Inclusin de libreras, recursos y archivos necesarios para WIN NT
#INCLUDE "WIN32API.INC"
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'PULSAR 3.0 Lite
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'Plsar packed functions
#INCLUDE "PULSAR30LITE.INC"


'Record defined in UDT (User Defined Types) for this demostration.
'This structure is used by NewConventionalDB$ packed function
'in the database creation and others functions during the access
'operations into database

TYPE Fields
    Apellido  AS STRING * 30    'last name field
    Nombres   AS STRING * 40    'first name field
    Email     AS STRING * 20    'e-mail field
    Web       AS STRING * 50    'web field
END TYPE
GLOBAL DatabaseRecord AS FieldS 'Database Record used in this program


'auxiliar subs (view descriptions into subs)

DECLARE SUB SaveTenRecordsInConvDB
DECLARE SUB ViewRecordsInConventionalDB(FilePath$,FileNameDataBase$)

'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    $REGISTER NONE

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MSGBOX "BEGIN DEMO",,"PULSAR 3.0 Lite - DATABASE MANAGER"

    'variables used in this program

    PulsarPath$="c:\pulsar"         'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename

    '--------------------------------------------------------------------
    'HOW TO VIEW ALL RECORDS SAVED IN YOU DATABASE?
    '
    'This sub allow view all record saved in you database, one to one
    'See complete description in ViewRecordsInConventionalDB sub

    CALL ViewRecordsInConventionalDB(PulsarPath$,PulsarFile$)


    '------------------------------------------------------------------
    MSGBOX "THE END!",,"PULSAR DATABASE MANAGER"

END FUNCTION


'------------------------------------------------------------------
'AUXILIAR SUB'S
'------------------------------------------------------------------

SUB ViewRecordsInConventionalDB(FilePath$,FileNameDataBase$)

   'this sub allow read all records saved in database

   LOCAL RecordsInDB$,RecordSaved$,Msg$


   'GetQuantityOfRecords$ function read the quantity of records saved
   'in you database

   RecordsInDB$=GetQuantityOfRecords$(FilePath$,FileNameDataBase$)

   IF LCASE$(LEFT$(RecordsInDB$,5))="error" THEN

      'If not error occur, function return the quantity or records saved in
      'you database in string format
      'If error occur, return "ERROR CODE:XXX.Error_Description" string into
      'RecordsInDB$ variable
      MSGBOX "Error reading quantity of records saved: "+RecordsInDB$
      EXIT SUB

   ELSE

      'the RecordsInDB$ variable contain the quantity of record saved in
      'database, the for/next structure allow read one to one

      FOR Reading&=1 TO VAL(RecordsInDB$)

         'the GetRecordConvDB$ function allow read a record in database, the
         'record number must be indicated in string format ( TRIM$(STR$(Reading&))
         'in this case )

         RecordSaved$=GetRecordConvDB$(FilePath$,FileNameDataBase$,TRIM$(STR$(Reading&)))
         IF LCASE$(LEFT$(RecordSaved$,5))="error" THEN

            'If not error occur, function return into the RecordSaved$ variable
            'the record readed.
            'If error occur, return "ERROR CODE:XXX.Error_Description" string into
            'the RecordSaved$ variable

            MSGBOX "Error reading record number:"+TRIM$(STR$(Reading&))
            EXIT SUB

         ELSE

            'error no occur, assign the RecordSaved$ variable data to
            'DatabaseRecord UDT structure
            POKE$ VARPTR(DatabaseRecord),RecordSaved$

            'show the record
            Msg$="RECORD N "+TRIM$(STR$(Reading&))+"/ "+TRIM$(RecordsInDB$)+CHR$(10)+CHR$(13)
            Msg$=Msg$+"  "+CHR$(10)+CHR$(13)
            Msg$=Msg$+"APELLIDO: "+DatabaseRecord.Apellido+CHR$(10)+CHR$(13)
            Msg$=Msg$+"NOMBRES: " +DatabaseRecord.Nombres+CHR$(10)+CHR$(13)
            Msg$=Msg$+"E-MAIL: "  +DatabaseRecord.Email+CHR$(10)+CHR$(13)
            Msg$=Msg$+"WEB: "     +DatabaseRecord.Web

            MSGBOX Msg$

         END IF

      NEXT Reading

   END IF

END SUB
