'-------------------------------------------------------------------
' ReadRecordDirectly.bas (c)2002 by Ricardo Daniel Ponce
' Source code in Rapid-Q 1.0.0
' Cdigo fuente en Rapid-Q 1.0.0
'
' Noviembre del 2002
' November 2002
'
' Plsar 3.0 (c)2002 by Ricardo Daniel Ponce
'                       rponce@lanet.com.ar
'
' HEPIKA SOLUTIONS                     HEPIKA SOLUTIONS
' Somos programadores... como usted    We are programmers... as you
' www.hepika.com.ar                    www.hepika.com.ar
'
' Funciones empaquetadas para operar Plsar 3.0
' Packed Functions for operate Plsar 3.0
'-------------------------------------------------------------------

'DECLARACION DE SUBRUTINAS PARA OPERAR PULSAR 3.0 CON RAPID-Q
'Sub declarations to operate Plsar 3.0 with Rapid-Q


DECLARE SUB RQ_PulsarEngine LIB "pulsar.dll" ALIAS "RQ_PulsarEngine"(RetFunction$)
DECLARE SUB RQ_PulsarBuild LIB "pulsar.dll" ALIAS "RQ_PulsarBuild"(RetFunction$)
DECLARE SUB RQ_NewConventionalDB LIB "pulsar.dll" ALIAS "RQ_NewConventionalDB"(RetFunction$,Structure$,IndexField$,PulsarPath$,PulsarFile$)
DECLARE SUB RQ_SaveIndexConvDB LIB "pulsar.dll" ALIAS "RQ_SaveIndexConvDB"(RetFunction$,PulsarPath$,PulsarFile$,RecordToSave$)
DECLARE SUB RQ_GetQuantityOfRecords LIB "pulsar.dll" ALIAS "RQ_GetQuantityOfRecords"(RetFunction$,PulsarPath$,PulsarFile$)
DECLARE SUB RQ_GetRecordConvDB LIB "pulsar.dll" ALIAS "RQ_GetRecordConvDB"(RetFunction$,PulsarPath$,PulsarFile$,RecordNumber$)
DECLARE SUB RQ_SINEConvDB LIB "pulsar.dll" ALIAS "RQ_SINEConvDB"(RetFunction$,PulsarPath$,PulsarFile$,RecordToSave$)
DECLARE SUB RQ_SaveConvDB LIB "pulsar.dll" ALIAS "RQ_SaveConvDB"(RetFunction$,PulsarPath$,PulsarFile$,RecordToSave$)
DECLARE SUB RQ_ReindexConvDB LIB "pulsar.dll" ALIAS "RQ_ReindexConvDB"(RetFunction$,PulsarPath$,PulsarFile$)
DECLARE SUB RQ_ReturnRecordByte LIB "pulsar.dll" ALIAS "RQ_ReturnRecordByte"(RetFunction$,PulsarPath$,PulsarFile$,RecordNumber$)
DECLARE SUB RQ_SARIndexConDB LIB "pulsar.dll" ALIAS "RQ_SARIndexConDB"(RetFunction$,PulsarPath$,PulsarFile$,DataToSearch$)
DECLARE SUB RQ_SARByteConDB LIB "pulsar.dll" ALIAS "RQ_SARByteConDB"(RetFunction$,PulsarPath$,PulsarFile$,DataToSearch$)
DECLARE SUB RQ_DeleteRecordConvDB LIB "pulsar.dll" ALIAS "RQ_DeleteRecordConvDB"(RetFunction$,PulsarPath$,PulsarFile$,RecordNumber$)
DECLARE SUB RQ_ModifyRecordConvDB LIB "pulsar.dll" ALIAS "RQ_ModifyRecordConvDB"(RetFunction$,PulsarPath$,PulsarFile$,NewRecordInDB$,RecordToModify$)
DECLARE SUB RQ_GetCounter LIB "pulsar.dll" ALIAS "RQ_GetCounter"(RetFunction$,PulsarPath$,PulsarFile$)
DECLARE SUB RQ_SetCounter LIB "pulsar.dll" ALIAS "RQ_SetCounter"(RetFunction$,PulsarPath$,PulsarFile$,NumberToSet$)
DECLARE SUB RQ_DeleteLog LIB "pulsar.dll" ALIAS "RQ_DeleteLog"(RetFunction$,PulsarPath$,PulsarFile$)
DECLARE SUB RQ_SaveInLog LIB "pulsar.dll" ALIAS "RQ_SaveInLog"(RetFunction$,PulsarPath$,PulsarFile$,TextToSave$)
DECLARE SUB RQ_ReadLog LIB "pulsar.dll" ALIAS "RQ_ReadLog"(RetFunction$,PulsarPath$,PulsarFile$)
'-------------------------------------------------------------------

    'Record defined in UDT (User Defined Types) for this demostration.
    'This structure is used by RQ_NewConventionalDB packed subroutine
    'in the database creation and others functions during the access
    'operations into database

    TYPE Fields
        Apellido  AS STRING * 30    'last name field
        Nombres   AS STRING * 40    'first name field
        Email     AS STRING * 20    'e-mail field
        Web       AS STRING * 50    'web field
    END TYPE
    DIM DatabaseRecord AS FieldS 'Database Record used in this program

    '------------------------------------------------------------------
    'BEGIN DEMO
    '------------------------------------------------------------------
    MESSAGEBOX("BEGIN DEMO: HOW TO READ A RECORD DIRECTLY FROM DATA FILE.", "Plsar 3.0 in RapidQ", mbOK)

    'variables used in this program

    PulsarPath$="d:\rapidq\pulsar"  'the database file is saved in this path
    PulsarFile$="Conventional_DB"   'database filename

    '--------------------------------------------------------------------
    'HOW TO READ A RECORD DIRECTLY FROM DATA FILE?
    '
    'If for any cause you need manipulate the data file that contain
    'the record obviating plsar intervention, get the initial byte in
    'data file that contain the searched record with the RQ_ReturnRecordByte
    'packed sub
    '
    'Warning!: The Plsar record manipulation contemplate the network
    '           permissions access. Through this method you expose the
    '           data at corruption or loss
    '
    'This routine allow get all the saved records in you database directly
    'from the data file, without plsar manager intervention


    'The RetFunction$ variable return in all pulsar subs the data
    'required by programmers
    RetFunction$=SPACE$(160)

    'get the quantity of record saved in you database
    RQ_GetQuantityOfRecords @RetFunction$,PulsarPath$,PulsarFile$

    IF LEFT$(RetFunction$,5)="ERROR" THEN
        'If record is deleted, the packed sub return "ok".
        'If error occur, function return error code in string
        'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
        Msg$="OPERATION IS NOT COMPLETED: "+LTRIM$(RTRIM$(RetFunction$))
        MESSAGEBOX(Msg$, "Plsar 3.0 in RapidQ", mbOK)
        END

    ELSE

        'quantity of record saved in you database is
        'saved into RecordsInDB$ variable in string
        'format

        RecordsInDB$=LTRIM$(RTRIM$(RetFunction$))

    END IF

    'plsar return the quantity of record saved in you database
    'and contain it into RecordsInDB$ variable in string
    'format

    DIM FileST AS QFileStream 'define the object FileST as File stream
                              '(see RapidQ Manual)

    'this for/next loop allow read records one to one directly
    'from you data file

    FOR Record%=1 TO VAL(RecordsInDB$)

       'the RQ_ReturnRecordByte packed sub return the initial byte
       'in data file that contain the searched record

       'The RetFunction$ variable return in all pulsar subs the data
       'required by programmers
       RetFunction$=SPACE$(160)

       'RecordToAnalize$ variable save the record number
       'which we needed
       RecordToAnalize$=LTRIM$(RTRIM$(STR$(Record%)))

       RQ_ReturnRecordByte @RetFunction$,PulsarPath$,PulsarFile$,RecordToAnalize$


       IF LEFT$(RetFunction$,5)="ERROR" THEN

           'If error occur, function return error code in string
           'format: "ERROR CODE:xxx...." (xxx is error code -see plsar manual-)
           Msg$="OPERATION IS NOT COMPLETED: "+LTRIM$(RTRIM$(RetFunction$))
           MESSAGEBOX(Msg$, "Plsar 3.0 in RapidQ", mbOK)
           END

       END IF

       'if error not occur, the RetFunction$ variable contain in
       'string format the byte number
       'save the byte number into ByteInicio$ variable
       ByteInicio$=LTRIM$(RTRIM$(RetFunction$))

       FileST.Open("d:\rapidq\pulsar\Conventional_DB.PLS",fmOpenRead) 'Open plsar file as file stream for only read method

       DummyString% = VAL(ByteInicio$)-1 'read the first bytes to placing the
       FOR DummyRead%=1 TO DummyString%  'reading pointer in record initial byte
          a$=FileST.ReadStr(1)           '(see RapidQ Manual)
       NEXT DummyRead%

       'Get data record directly from plsar data file
       'and save it into RecordRead$ variable.
       'Remember that DatabaseRecord UTD structure are
       '140 bytes long.
       RecordRead$=FileST.ReadStr(140)

       'If error no occur, assign the RecordRead$ variable data to
       'DatabaseRecord UDT structure
       DatabaseRecord.Apellido=LEFT$(RecordRead$,30)
       DatabaseRecord.Nombres=MID$(RecordRead$,31,40)
       DatabaseRecord.Email=MID$(RecordRead$,71,20)
       DatabaseRecord.Web=MID$(RecordRead$,91,50)

       'show the record
       Msg$="APELLIDO: "+DatabaseRecord.Apellido+CHR$(10)+CHR$(13)
       Msg$=Msg$+"NOMBRES: "+DatabaseRecord.Nombres+CHR$(10)+CHR$(13)
       Msg$=Msg$+"E-MAIL: "+DatabaseRecord.Email+CHR$(10)+CHR$(13)
       Msg$=Msg$+"WEB: "+DatabaseRecord.Web

       MESSAGEBOX(Msg$, "Plsar 3.0 in RapidQ", mbOK)

    NEXT Record&

    '------------------------------------------------------------------
    MESSAGEBOX(" THE END !", "Plsar 3.0 in RapidQ", mbOK)

    'End program
    END
