 $Include "TRM_RQDeclares.INC"
 
 DIM CmdTsu  AS TRMType

'\--- Construct the File Definition string ---------------------------\


FUNCTION AddDefOfKey(Sender as TRMdKey) AS String
    Sender.FDef = RTrim$(Sender.FDef) + _
            Sender.SegName + _                                          ' Segment description
            chr$(Sender.KeyNo) + _                                      ' Key number = 1
            chr$(Sender.KeyPos Mod 256) + chr$(Sender.KeyPos / 256) + _ ' Segment's position
            chr$(Sender.KeyLen) + _                                     ' Segment's length
            chr$(Sender.KeyFlags)
            
    result = Sender.FDef
END FUNCTION

 DIM FDefKey  as TRMdKey
 DIM FDef     as STring 
 DIM FileName  as String
 DIM Result    as LONG
 DIM OverWrite as LONG


 FDefKey.PageSize = 1     ' Page size = 1K
 FDefKey.Compress = 1     ' Compress records in file
 FDefKey.Segments = 3     ' 4 key segments will be defined (3 keys)
 
 FDefKey.FDef = chr$(FDefKey.PageSize) + _
                  chr$(FDefKey.Compress) + _
                  chr$(FDefKey.Segments)
         
 '\---Introducing 1st key --------------------------------------------\

 FDefKey.SegName  = "Employee ID Number"        
 FDefKey.KeyNo    = 1
 FDefKey.KeyPos   = 1
 FDefKey.KeyLen   = 6
 FDefKey.KeyFlags = 0

FDef = AddDefOfKey (FDefKey)    '---Add the key definition

 '\---Introducing 2nd key --------------------------------------------\

 FDefKey.SegName  = "Last Name, First Name, MI"        
 FDefKey.KeyNo    = 2
 FDefKey.KeyPos   = 7
 FDefKey.KeyLen   = 25
 FDefKey.KeyFlags = 0

FDef = AddDefOfKey (FDefKey)    '\---Add the key definition

 '\---Introducing 3rd Key --------------------------------------------\

 FDefKey.SegName  = "Department Number"        
 FDefKey.KeyNo    = 3
 FDefKey.KeyPos   = 32
 FDefKey.KeyLen   = 5
 FDefKey.KeyFlags = NO_COMPRESSION

FDef = AddDefOfKey (FDefKey)    '\---Add the key definition


'\--- Create the Tsunami file ----------------------------------------\

 OverWrite = 0
 FileName  = "dBase.pdb"

 CmdTsu.op = Tsu_Create
 CmdTsu.dataptr = VARPTR(FDef)
 CmdTsu.datalen = LEN(FDef)
 CmdTsu.keyptr = VARPTR(FileName)
 CmdTsu.keylen = LEN(FileName)
 CmdTsu.keyno = OverWrite
 
 Result = trm_udt(CmdTsu)
 
Select Case Result
    case 0    : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create was sucessfull"
    Case 2    : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered I/O errors"
    case 10   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered invalid page size"
    case 11   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered invalid number of key segments"
    case 12   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered invalid file definition string"
    case 13   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered invalid key segment position"
    case 14   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered invalid key segment length"
    case 15   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered inconsistent key segment definitions"
    case 31   : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered file already exists"
    case else : showmessage "CODE: "& STr$(Result) &": Trm_Operation trm_Create encountered Unknown Error"
End Select 
